<?php
/**
* @package EverLive.net Ev Security Watch for Joomla 3.x
* @version $Id: 100 2017-28-02 $
* @author EverLive.net
* @copyright (C) 2017 EverLive.net. All rights reserved.
* @license GNU/GPLv3 http://www.gnu.org/licenses/gpl-3.0.html
**/

// no direct access
defined( '_JEXEC' ) or die( 'Restricted access' );
if (!defined('DS')) define('DS','/');

require_once('admin.ev_secuwatch.html.php');
require_once( JPATH_ADMINISTRATOR.'/components/com_ev_secuwatch/helper.php' );

if (!defined('EV_SECUWATCH_IS_PRO')){
	$fn = JPATH_ADMINISTRATOR.'/components/com_ev_secuwatch/ev_secuwatch_helper_pro.php';
	if (file_exists($fn)){
		require_once($fn);
		define('EV_SECUWATCH_IS_PRO',true);	//true
	}else{
		define('EV_SECUWATCH_IS_PRO',false);
	}
}

$jInput = JFactory::getApplication()->input;
$option	= strtolower( $jInput->getCmd('option') );
$view	= strtolower( $jInput->getCmd('view') );
$task	= strtolower( $jInput->getCmd('task') );

$id	= (int) $jInput->request->get('id',0);
$cid= $jInput->post->get('cid',array(0));

JArrayHelper::toInteger($cid, array(0));

require_once('toolbar.ev_secuwatch.html.php');
require_once('toolbar.ev_secuwatch.php');

switch ($task)
{
	case 'watchlive':
		watchlive( $option, $task );
		break;
		
	case 'delrequest': 			delrequest($option, $cid); break;
	case 'get_latest_reqs':		get_latest_reqs(); break;
	case 'get_req_details':		get_req_details(); break;
	case 'add_action'	  :		add_action(); break;	//adding rule actually.
	case 'delete_rule'	  :		delete_rule(); break;
	case 'recheck_rid'	  : 	recheck_rid(); break;
	case 'load_bots_in_table':	load_bots_in_table(); break;
	case 'show_settings':		show_settings(); break;
	
	//case 'list_rules':			list_rules(); break;
		
	default:
		$app = JFactory::getApplication();
		$app->redirect( 'index.php?option=com_ev_secuwatch&task=watchlive' );	
}

return;

function show_settings(){
	if (EV_SECUWATCH_IS_PRO){
		$oPro = new EvSecuWatchHelperPro;
		$oPro->show_settings();
	}
}

function load_bots_in_table(){
	EvGeneCompoHelperSW::noCacheHeaders();
	EvGeneCompoHelperSW::loadBotsInTable(true);
	die();
}

function recheck_rid(){
	$app = JFactory::getApplication();
	if (EV_SECUWATCH_IS_PRO){
		$oPro = new EvSecuWatchHelperPro;
		$oPro->recheck_rid();
	}else{
		$url = JURI::base() . 'index.php?option=com_ev_secuwatch&task=watchlive';
		$app->redirect($url, 'Sorry, this feature is available in PRO Version only.', 'alert');
	}
}

function delete_rule(){
	if (EV_SECUWATCH_IS_PRO){
		$oPro = new EvSecuWatchHelperPro;
		$oPro->deleteRule();
	}
}

function add_action(){	//is is submitted in iframe
	$app = JFactory::getApplication();

	$url = JURI::base() . 'index.php?option=com_ev_secuwatch&task=watchlive';
	if (!EV_SECUWATCH_IS_PRO){
		$app->redirect($url, 'Feature is available in PRO Version only.', 'alert');
	}
	//
	$oPro = new EvSecuWatchHelperPro;
	$oPro->add_action_pro($url);
}

function get_req_details(){
	$jInput = JFactory::getApplication()->input;
	$rid	= (int) $jInput->request->get('rid',0);
	
	$q = getBaseQuery();
	$q.= " WHERE id = '$rid' ";
	//die($q);
	$r = EvGeneCompoHelperSW::getRow($q);
	$r->formatted_row = EvGeneCompoHelperSW::formatReqThisRow($r,0, $r->id);
	
	$md = EvGeneCompoHelperSW::mdReadFromDb( $r->more_details );
	$mds = $md[0];	//$_SERVER

	$tmp2 = trim($r->request_url,'/');
	$reqUrl = '<a target="blank" href="' .JURI::root().$tmp2 .'" >'.$r->request_url . '</a>';

	$st = '<b>'. JText::_('COM_EV_SECUWATCH_BE_WATCH_LIVE_LIST_STATUS') . ':</b> ';
	if ($r->recon_status >= 90) $st.='<span style="color:red">';
	$st.= $r->status_text;
	if ($r->recon_status>=90) $st.='</span>';
	
	$st .= EvGeneCompoHelperSW::actionShow($r, true);
	if (@$r->req_reason!='') $st .= '<br><b>'.JText::_('Reason: ') . '</b>'. ucwords( $r->req_reason );
	
	$mi = '';
	//if ($md[1]['is404']==1) $mi .= '404 - URL Not found<br>';
	if (@$r->is_404==1) $mi .= '404 - URL Not found<br>';
	$mi.= '<b>User Agent:</b> '.$mds['HTTP_USER_AGENT'] . '<br>';
	
	if (@$mds['REMOTE_HOST']=='') $mds['REMOTE_HOST']='N/A';
	$mi.= '<b>Visitor Host Name:</b> '.$mds['REMOTE_HOST']. '<br>';
	$mi.= '<b>Referer:</b> '.@$mds['HTTP_REFERER']. '<br>';
	
	if (@$r->is_js==1) $mi.= 'JS Test: Passed'. '<br>';

	$flag = ''; $path = 'administrator/components/com_ev_secuwatch/flags/24/'.strtoupper(@$r->country_code) . '.png';
	if (file_exists( JPATH_ROOT . '/' . $path )){ 
		$flag = '<img src="'. JURI::root(). $path.'" />';
	}
	
	$dis = ' disabled="disabled" ';$pv=' (Pro Only)'; $liveSearch='';
	if (EV_SECUWATCH_IS_PRO) { $dis=' ';$pv=''; }
	
	$dis = ' style="margin-right:5px;" class="btn btn-danger" '.$dis;
	$dis2= ' style="margin-right:5px;" class="btn btn-success" '.$dis;

	if (EV_SECUWATCH_IS_PRO) { 
		$liveSearchX=' <a title="Perform a live search in online security database on EverLive.net" '.$dis2
					.' >Search in EverLive Security DB'.$pv
					.'</a>'; 
	}	
	
	$minDD = '<select id="evsw_dtl_mindd" name="evsw_dtl_mindd" style="margin-top:5px">
				<option value="10"  selected="selected" >10 minutes</option>
				<option value="30">30 minutes</option>
				<option value="60">1 hour</option>
				<option value="120">2 hours</option>
				<option value="300">5 hours</option>
				<option value="600">10 hours</option>
				<option value="1440">24 hours</option>
				<option value="10080">7 Days</option>
				<option value="43200">30 Days</option>
				<option value="99">Forever</option>
			  </select>';
	
	$href = JURI::base() . 'index.php?option=com_ev_secuwatch&task=add_action&rid='.$r->id;
	
	$appliedRules = '';
	if (EV_SECUWATCH_IS_PRO){
		$oPro = new EvSecuWatchHelperPro;
		$appliedRules = $oPro->getAppliedRulesHtml( @$r->applied_rule_id, true );
	}
	
	$action = '<h4>Add New Rule</h4>';
	$action.= 'For next '.$minDD.' ';
	
	$href2 = '';
	if (@$r->country_code!=''){
		$href2 = '&country_code='. $r->country_code;
		$btn = ' onclick="evsw__addRuleSubmit(\''.$href2.'\'); return false;" ';
		$action.= '<a  '.$btn .$dis.' >Block Country'.$pv.'</a>';
	}
	
	if (@$r->ip!=''){
		$href2 = '&ip='. $r->ip;
		$btn = ' onclick="evsw__addRuleSubmit(\''.$href2.'\'); return false;" ';
		$action.= '<a '.$btn .$dis.' >Block IP'.$pv.'</a>';
		$action.= EvGeneCompoHelperSW::getHelpLinkWithIco('#more_help');
	}
		
	if (@$r->request_url!=''){
		$href2 = '&request_url='. $r->request_url;
		$btn = ' onclick="evsw__addRuleSubmit(\''.$href2.'\'); return false;" ';
		$action.= '&nbsp; <a '.$btn. $dis.' >Block URL'.$pv.'</a>';
		$action.= EvGeneCompoHelperSW::getHelpLinkWithIco('#more_help');		

		$href2 = '&subseq_block=1&request_url='. $r->request_url;
		$btn = ' onclick="evsw__addRuleSubmit(\''.$href2.'\'); return false;" ';
		$action.= '&nbsp; <a '.$btn. $dis.' >Block URL & Visitor'.$pv.'</a>';
		$action.= EvGeneCompoHelperSW::getHelpLinkWithIco('#more_help');				
	}
	
	$action2 = '';
	if (@$r->bot_id>0){
		if (@$r->is_bad==0){
			$href2 = '&bot_id='. $r->bot_id;
			$btn = ' onclick="evsw__addRuleSubmit(\''.$href2.'\'); return false;" ';
			$action2.= '<a ' . $btn	.$dis.' >Block BOT'.$pv.'</a>';
			$action2.= EvGeneCompoHelperSW::getHelpLinkWithIco('#more_help2');
		}
	}
	
	if (@$r->bot_id>0){
		if (@$r->is_bad==1){
			if (@$r->bot_verify_url!=''){	//verifieable bot.
				$href2 = '&allow=1&bot_id='. $r->bot_id;
				$btn = ' onclick="evsw__addRuleSubmit(\''.$href2.'\'); return false;" ';
				$action2.= '<a '.$btn.$dis2.' >Allow BOT'.$pv.'</a>';
				$action2.= EvGeneCompoHelperSW::getHelpLinkWithIco('#more_help2');
				
			}else{	//can be deleted from bots list.
				$href2 = '&allow=9&bot_id='. $r->bot_id;
				$btn = ' onclick="evsw__addRuleSubmit(\''.$href2.'\'); return false;" ';
				$action2.= '<a '.$btn.$dis2.' title="Exclude this from Bots list. Do not consider it a bot." >Exclude BOT'.$pv.'</a>';
				$action2.= EvGeneCompoHelperSW::getHelpLinkWithIco('#more_help2');
			}
		}
	}
	
	if ($action2 != '') $action2 = '<h4>Other Actions</h4>' . $action2;
	
	$bts = EvGeneCompoHelperSW::botShow($r, true);
	if ($bts!=''){
		$bts = '<tr><td colspan="2">'.$bts.'</td></tr>';
	}
	
	$h = '<html><head>
			<link href="templates/isis/css/template.css" rel="stylesheet" type="text/css" />
			</head>
			<body>
			<div style="padding:10px;">
			<form id="req_details" name="req_details" action="'.$href.'" method="post" target="_parent" >
			<h1>IP Address: '.$r->ip .'</h1>
			<span style="float:right;">'
					. $liveSearch .'</span>
			<div>'.$flag.' '.$r->city. ' '
			.$r->zip_code .($r->zip_code!='' ? ', ' : '') 
			.$r->region_name . ($r->region_name!='' ? ', ' : '') 
			.$r->country_name .'
			</div>
			<div id="evsw_dtl_evnet_res"></div>
			<table class="adminlist table table-striped" style="width:100%; font-size:13px; margin-top:10px">
				<tr>
					<td>'. EvGeneCompoHelperSW::time_elapsed_string( $r->date_time ) . ' &nbsp;('. $r->date_time .')'.'</td>
					<td>URL&nbsp;&nbsp; '.$reqUrl.'</td>
				</tr>
				<tr><td colspan="2">'.$mi.'</td></tr>
				
				'.$bts.'
				
				<tr><td colspan="2">'.$st.'</td></tr>
				
				'.$appliedRules.'
				<tr><td colspan="2">'.$action. $action2.'</td></tr>
			</table>
			</div>
			<input type="hidden" name="rule_created_by" value="0" />
			</form>
			
			<script type="text/javascript">
				function evsw__addRuleSubmit(str){
					var fm = document.getElementById("req_details");
					if (fm){
						fm.action += str;
						fm.submit();
					}
				}
			</script>
			
			</body>
			</html>
		 ';
		 
	EvGeneCompoHelperSW::noCacheHeaders();
	echo $h;
	die();
}

function getBaseQuery(){
	$ary = HTML_ev_secuwatch::getStatusVals(0, $bAll=true);
	
	$q	 = "SELECT cd.*,
				CASE 
					WHEN cd.recon_status = '0'   then '".$ary[0]."'
					WHEN cd.recon_status = '10'  then '".$ary[10]."'
					WHEN cd.recon_status = '19'  then '".$ary[19]."'
					WHEN cd.recon_status = '80'  then '".$ary[80]."'
					WHEN cd.recon_status = '99'  then '".$ary[99]."'
					ELSE '' 
				END as status_text
				,ips.ip as ip2, ips.country_code, ips.country_name, ips.city, ips.latitude, 
				ips.longitude, ips.region_code, ips.region_name, ips.zip_code, ips.metro_code, 
				ips.time_zone, bt.bot_name, bt.is_bad, bt.bot_verify_url, ru.rule_id, ru.rule_action
				
				FROM #__ev_secuwatch_requests cd
				LEFT JOIN #__ev_secuwatch_ips ips ON cd.ip = ips.ip
				LEFT JOIN #__ev_secuwatch_bots bt ON cd.bot_id = bt.bot_id
				LEFT JOIN #__ev_secuwatch_rules ru ON cd.applied_rule_id = ru.rule_id
				";
	return $q;
}

function get_latest_reqs(){
	$jInput = JFactory::getApplication()->input;
	$lastid	= (int) $jInput->request->get('lastid',0);
	$lastk	= (int) $jInput->request->get('lastk',0);
	
	$ary = HTML_ev_secuwatch::getStatusVals(0, $bAll=true);

	$session = JFactory::getSession();
	$last_time = $session->get('evsw__last_reqload_at',0);
	if ($last_time<=0) $last_time = time();
	$session->set('evsw__last_reqload_at',time() - 0.1);
	
	$q = getBaseQuery();
	$q.= " WHERE UNIX_TIMESTAMP(cd.add_modif_time) > '$last_time' 
					ORDER BY cd.id
					LIMIT 0,100";
	//die($q);
	//cd.id > '$lastid' OR 	
	EvGeneCompoHelperSW::debugje('get_latest_r^eqs: $q = '.$q );
	
	$rows = EvGeneCompoHelperSW::getRows($q);
	$rows = EvGeneCompoHelperSW::formatReqRows($rows,$lastk,$lastid);
	//$ar[] = $rows;
	
	if ( count($rows)>0 ){
		echo json_encode($rows); 
	}
	
	EvGeneCompoHelperSW::sendRequestToCheckThisRequest();
	die();
}

function delRequest( $option, $cid ){
	EvGeneCompoHelperSW::delGene( $cid, '#__ev_secuwatch_requests', "index.php?option=$option&task=watchlive" );
}

function watchlive( $option, $task ){
	$mainframe = JFactory::getApplication();
	$db		   = JFactory::getDBO();

	//gene filters etc.
	$lists = array();
	list($filter_order,$filter_order_Dir,$filter_state,$limit,$limitstart,$search) 
		= EvGeneCompoHelperSW::geneFiltersEtc($mainframe, $option, $task, $lists, 'id', 'DESC' );
	
	//get custom filters
	$where_filter='';
	// $arf=array('letter_group');
	// $ar = EvGeneCompoHelperSW::geneUserState($mainframe, $option, $task, $lists, $arf, $where_filter );
	
	$where  = " WHERE 0 = 0 ";

	$jInput = JFactory::getApplication()->input;
	$isft	= (int) $jInput->request->get('isft',0);
	
	if (EV_SECUWATCH_IS_PRO){
		$oPro = new EvSecuWatchHelperPro;
		$oPro->applyProFilters($where);
	}else{
		if ($isft>0){
			$u = 'index.php?option=com_ev_secuwatch&task=watchlive';
			$app = JFactory::getApplication();
			$m = JText::_('Sorry, this option is available in PRO Version Only.');
			$app->redirect( $u, $m );
		}
	}

	$where .= $where_filter;	//dropdown filters

	//
 	if ( $search ) {
		$where .= ' AND (';
		$where .= 	' cd.ip LIKE '.$db->Quote( '%'.$search .'%');
		$where .= 	' OR cd.request_url LIKE '.$db->Quote( '%'.$search .'%');
		$where .= ') ';
	}
	//die($where);
	$orderby 	= ' ORDER BY '. $filter_order .' '. $filter_order_Dir;

	$qjn = " FROM #__ev_secuwatch_requests cd 
				LEFT JOIN #__ev_secuwatch_ips ips ON cd.ip = ips.ip
				LEFT JOIN #__ev_secuwatch_bots bt ON cd.bot_id = bt.bot_id
				LEFT JOIN #__ev_secuwatch_rules ru ON cd.applied_rule_id = ru.rule_id	
				";
	$query = "SELECT COUNT(cd.id) ". $qjn . $where;
	$total = EvGeneCompoHelperSW::getResult( $query );

	jimport('joomla.html.pagination');
	$pageNav = new JPagination( $total, $limitstart, $limit );

	$query = getBaseQuery()  . $where . $orderby;
	//echo $query;
	//die($query);
	
	$session = JFactory::getSession();
	$session->set('evsw__last_reqload_at',time());
	$rows = EvGeneCompoHelperSW::getRows($query, $pageNav->limitstart, $pageNav->limit);
	
	$arf = array();
	HTML_ev_secuwatch::listAll( $rows, $pageNav, $option, $lists, $task, $arf );
}


