<?php
/**
* @package EverLive.net Ev Security Watch for Joomla 3.x
* @version $Id: 100 2017-28-02 $
* @author EverLive.net
* @copyright (C) 2017 EverLive.net. All rights reserved.
* @license GNU/GPLv3 http://www.gnu.org/licenses/gpl-3.0.html
**/

// no direct access
defined( '_JEXEC' ) or die( 'Restricted access' );

class EvGeneCompoHelperSW{
	static $tblPfx = '';

	public static function mdReadFromDb($md){
		$md = @unserialize( self::hexToStr($md) );
		
		return $md;
	}
	
	public static function mdMakeToSave($ar){
		$db = JFactory::getDbo();
		$md		= self::strToHex( serialize( $ar ) );
		return $md;
	}
	
	public static function getHtaccessMsg(){
		$h2 = '';
		$fn = JPATH_ROOT.'/.htaccess';
		if (!file_exists($fn)){
			$h2.= '<div style="color:red">'.
			EvGeneCompoHelperSW::getHelpLinkWithIco('#more_help3')
			.'.htaccess file is not available in your website root folder. You must first rename your htaccess.txt file to .htaccess to enable basic Joomla htaccess security</div><br>';
		}
		
		return $h2;
	}
	
	public static function getHelpLinkWithIco($url){
		$url = 'http://www.everlive.net/joomla-extensions/43-joomla-security-watch.html' . $url;

		$h = '';
		$h.= '<a target="_blank" href="'.$url.'">';
		$h.= '<span class="icon-info"></span>';
		$h.= '</a>';
		
		return $h;
	}
	
	public static function getBotRows($ua){
		$ua		= filter_var ( $ua, FILTER_SANITIZE_STRING);
		self::debugje('getBotR^ows: $ua = '.$ua );
		
		if (stripos($ua,'$_SERVER')!==false){
			self::debugje('getBotR^ows: Invalid Useragent. Hacking attempt.' );
			return -1;
		}
	
		$db = JFactory::getDbo();
		try{
			$bots = self::getRowsPz(array('bt.bot_id','bt.bot_name','bot_verify_url','is_bad')
						, '#__ev_secuwatch_bots', 'bt'
						, 'INSTR('. $db->Quote($ua) .','. $db->quoteName('bot_name').') > 0', null, 1);
		}catch(exception $e){
			self::debugje('getBotR^ows: Invalid Useragent. Spoofing or Hacking attempt.' );
			$bots = -1;
		}
		return $bots;
	}
	
	public static function addJs($url){
		$doc = JFactory::getDocument();
		$doc->addScript($url);
	}

	public static function markJs($rid){
		$q	 = "UPDATE #__ev_secuwatch_requests SET is_js ='1' 
						, add_modif_time = CURRENT_TIMESTAMP
					WHERE id = '". $rid ."'
					";
		EvGeneCompoHelperSW::doQuery($q);	
	}

	public static function detectBotFree(&$r, $md){
		$mds = $md[0];
		$ua 	= @$mds['HTTP_USER_AGENT'];
		
		$bots = self::getBotRows($ua);
		if($bots == -1) return array(-1,false); 
					
		$arr = array(); $bot_id = 0;
		foreach($bots as $bt){
			self::debugje_dump('detectBotF^ree: $bt = ',$bt );
			
			$bot_id = @$bt->bot_id;
			
			return array($bot_id);
		}
		
		return array(0);
	}

	public static function loadBotsInTable($bShow=false){
		$fn = JPATH_ADMINISTRATOR.'/components/com_ev_secuwatch/bbl.php';
		if (!file_exists($fn)){
			$fn = 'admin/bbl.php';
			if (!file_exists($fn))return;
		}
		
		include_once($fn);
		foreach($wp_sbb_blacklist as $bot){
			$bn = trim(@$bot['botnickname']);
			if ($bn=='') continue;
			
			if ($bShow) echo 'Loading '. $bn .'<br>';
			
			$q = "INSERT IGNORE INTO #__ev_secuwatch_bots 
					(bot_name, bot_verify_url, is_bad) 
					VALUES ( '$bn','','1') ";
			self::doQuery($q);
		}
	}

	public static function getReqRecByToken($token){
		$db = JFactory::getDbo();
		$q	 = "SELECT * FROM #__ev_secuwatch_requests 
					WHERE ".$db->quoteName('token')." = '$token' ";		
		
		EvGeneCompoHelperSW::debugje('getReqRecByTo^ken: $q = '.$q);
		
		$row = self::getRow($q);
		return $row;
	}
	
	public static function noCacheHeaders(){
		@header("Cache-Control: no-store, no-cache, max-age=0");		
		@header("Expires: Mon, 26 Jul 1997 05:00:00 GMT");
	}
	
	public static function requestedIP(){
		$ip		= self::getJInputVar('ip','');
		
		$tmp 	= ip2long ( $ip );
		if ( long2ip( $tmp ) != $ip || $tmp==0 ) return '';
		
		return $ip;
	}
	
	public static function getReqRowById($rid){
		$q    = "SELECT * FROM #__ev_secuwatch_requests WHERE id = '$rid' ";
		self::debugje('getReqRowB^yId: $q = '.$q);
		$r 	  = self::getRow($q);	
		
		return $r;
	}

	public static function time_elapsed_string($datetime, $full = false) {
		$now = new DateTime;
		$ago = new DateTime($datetime);
		$diff = $now->diff($ago);

		$diff->w = floor($diff->d / 7);
		$diff->d -= $diff->w * 7;

		$string = array(
			'y' => 'year',
			'm' => 'month',
			'w' => 'week',
			'd' => 'day',
			'h' => 'hour',
			'i' => 'minute',
			's' => 'second',
		);
		foreach ($string as $k => &$v) {
			if ($diff->$k) {
				$v = $diff->$k . ' ' . $v . ($diff->$k > 1 ? 's' : '');
			} else {
				unset($string[$k]);
			}
		}

		if (!$full) $string = array_slice($string, 0, 1);
		return $string ? implode(', ', $string) . ' ago' : 'Just now';
	}

	public static function getTokenFromReq(){
		$token		= self::getJInputVar('token','');
		
		$tmp = explode('.',$token);
		$token = (float) $tmp[0] . '.' . (float) $tmp[1];	
		
		return $token;
	}

	public static function init_ip_info($ip){
		$url = JURI::root().'index.php';		
		$data = 'option=com_ev_secuwatch&tmpl=component&view=get_ip_info&ip='.$ip;
		self::getCurl($url, true, $data);
	}
	
	public static function formatReqRows(&$rows, $k, $m){
		for ($i=0, $n=count($rows); $i < $n; $i++) {
			$rows[$i]->formatted_row = self::formatReqThisRow($rows[$i],$k, $i);
		}
		$k=1-$k;
		return $rows;
	}
	
	public static function getFilterHtml($field,$val){
		$thisPage = JURI::base() . 'index.php?option=com_ev_secuwatch&task=watchlive&isft=1';
		
		$ft = '';
		if ($val!=''){
			$ft = str_ireplace('&'.$field.'='.$val,'',$thisPage) 
					. '&'.$field.'='.$val;
			$ft = '<a href="'.$ft.'"><span class="icon-filter small"></span></a>';
		}
		return $ft;
	}
	
	public static function getBanLinkHtml($rid){
		//mode 9 is ban
		$url = JURI::base() . 'index.php?option=com_ev_secuwatch&task=get_req_details&mode=9&rid='.$rid;
		$h = self::getIframeCode($url,'<span class="icon-ban-circle small"></span>','',$rid);
		
		return $h;
	}	

	public static function getRefreshHtml($rid){
		$url = JURI::base() . 'index.php?option=com_ev_secuwatch&task=recheck_rid&rid='.$rid;
		$h = '<a href="'.$url.'"><span class="icon-lightning small"></span></a>';
		
		return $h;
	}
	
	public static function getProLink($text='(Pro Only)', $extra=''){
		$h = '<a '.$extra.' href="http://www.everlive.net/joomla-extensions/43-joomla-security-watch.html"
					target="_blank" title="'.JText::_('Pro Version Only').'">'.$text.'</a>';
		return $h;
	}
	
	public static function formatReqThisRow(&$r, $k, $i, $ajax=true){
		$h = '';
		
		$md = self::mdReadFromDb( $r->more_details );
		
		$mds = $md[0];	//$_SERVER
		
		$bn = self::getBanLinkHtml(@$r->id);
		
		$tmp = " evsw_list_tr_".$r->recon_status;
		$h.= '<tr id="evsw_list_rqrow'.$r->id.'" class="row'. $k . $tmp .'">';

		$h.='<td><input type="checkbox" id="cb'.$i.'" name="cid[]" value="'.$r->id .'" 
					onclick="Joomla.isChecked(this.checked);"></td>';
		
		$ft = self::getFilterHtml('filter_id',@$r->id);
		$rfr= self::getRefreshHtml(@$r->id);
		$h.= '<td style="white-space:nowrap;">' 
				. $ft . $r->id .'<br>'. $rfr . '</td>';
		
		$ft = self::getFilterHtml('filter_is_admin',@$r->is_admin);
		
		$tmp = JText::_('COM_EV_SECUWATCH_BE_GENE_LBL_SITE'); 
		if ($r->is_admin=="1") $tmp = JText::_('COM_EV_SECUWATCH_BE_GENE_LBL_ADMIN');
		$h.= '<td>'. $ft. $tmp . '</td>';

		$flag = ''; 
		if (EV_SECUWATCH_IS_PRO){
			$path = 'administrator/components/com_ev_secuwatch/flags/24/'.strtoupper(@$r->country_code) . '.png';
		}else{
			$path = 'administrator/components/com_ev_secuwatch/images/gene-flag.png';
			$r->country_code = '??';
		}
		
		$ft = '';
		$ft = self::getFilterHtml('filter_country',@$r->country_code);
		$ft.=$bn;
		if (file_exists( JPATH_ROOT . '/' . $path )){ 
			$flag = '<img width="24" src="'. JURI::root(). $path.'" />';
		}
		$flag = $ft . $flag;
		if (!EV_SECUWATCH_IS_PRO) $flag.='<br>'.self::getProLink();
		
		$h.= '<td>' . $flag  . '</td>';

		$ft = self::getFilterHtml('filter_ip',@$r->ip);	
		
		if (!EV_SECUWATCH_IS_PRO && $i==0 && !$ajax){
			$r->country_name = 'Unknow Country. This feature is available in PRO Version.';
			$r->country_code = 'Country? <br>(Pro Only)';
			@$r->city		 = 'City?';
		}
		$cn = @$r->country_code;
		$h.= '<td title="'.@$r->country_name.'">' . $ft . $r->ip .'<br>' 
					. $bn . @$r->city . ' ' . $cn . '</td>';	
		//x $h.= '<td title="'. $r->date_time .'" >' . self::time_elapsed_string( $r->date_time ) . '</td>';
		$h.= '<td><time id="evsw_list_time_'.$r->id.'" class="timeago" datetime="'
					.date("c", strtotime($r->date_time)).'">'
					. $r->date_time .'</time></td>';

		//
		$ft = '';
		if (@$r->request_url!=''){
			$ft = self::getFilterHtml('filter_requrl', 'none');	
			
			if (EV_SECUWATCH_IS_PRO){
				$oPro = new EvSecuWatchHelperPro;
				$ft = self::getFilterHtml('filter_requrl', $oPro->uecd(@$r->request_url));	
			}
			$ft.=$bn;
		}
		
		$tmp2 = ltrim($r->request_url,'/');
		$tmp = $ft . '<a target="blank" href="' .JURI::root().$tmp2 .'" >'.$r->request_url . '</a>';
		$h.= '<td>'. $tmp . '</td>';
		
		//status
		$ft = self::getFilterHtml('filter_rcnstat',@$r->recon_status);	
		if (@$r->recon_status!=10) $ft.=$bn;

		if ($r->applied_rule_id > 0){
			if (@$r->rule_id>0) $r->status_text .= '<br>'.'Rule Applied';
			
		}elseif ($r->bot_id > 0 || $r->bot_spoofing==1){
			$r->status_text .= '<br>' . self::botStatus($r);
		}
		$h .= '<td class="evsw_list_rst_'.$r->recon_status . '" id="evsw_list_rid'.$r->id.'">'
						. $ft . $r->status_text . '</td>';
		$r->formatted_rcns = $ft . $r->status_text;
		
		//action
		$tmp = self::actionShow($r, false, $bn);
		$r->formatted_act = $tmp;
		$h.= '<td id="evsw_list_act'.$r->id.'">'.$tmp.'</td>';
		
		
		$tmp = '';
		$ft = self::getFilterHtml('filter_is_404',@$r->is_404);
		//if (@$md[1]['is404']==1) $tmp .= '404 Not found<br>';
		if ($r->is_404==1) $tmp .= $ft.'404 Not found<br>';
		
		$tmp = '<span id="evsw_list_mi'.$r->id.'">'.$tmp. self::botShow($r).'</span>';
		$r->formatted_mi = $tmp;
		
		$url = 'index.php?option=com_ev_secuwatch&task=get_req_details&rid='.$r->id;
		$tmp.= self::getIframeCode($url, JText::_('COM_EV_SECUWATCH_BE_WATCH_LIVE_LIST_MOREINFO_LINK')
					, 'evsw_rql_md_'.$r->id );
		
		$h.= '<td style="text-align:center">'.$tmp.'</td>';
		$h.= '</tr>';	
		
		$r->formatted_row = $h;
		
		return $h;
	}
	
	public static function actionShow(&$r, $isDetail=false, $bn=''){
		$h='';
		$tmp = ''; $tmp2 = '';
		$tmp2 = $r->applied_rule_id;
		if ($tmp2 > 0){
			if (!$isDetail) $tmp2 = '<br>'; else $tmp2 = ' ';
			$tmp2.= 'Rule ID - '.$r->applied_rule_id;
		}

		$ad = '<span style="color:green;">Allowed</span>';
		$bk = '<span style="color:red;">Blocked</span>';
		$nn = 'Analysis';
		
		if (@$r->rule_action>0){		//rule is available in db.
			if (@$r->rule_action == 10){
				$tmp = $ad.$tmp2;
				if ($r->is_blocked==1) $tmp = $nn.$tmp2;
			}
			if (@$r->rule_action == 99){
				$tmp = $bk.$tmp2; 
				if ($r->is_blocked==0) $tmp = $nn.$tmp2;
			}
		}elseif (@$r->applied_rule_id>0){	//rule was applied but now removed to save space in table.
			if ($r->is_blocked==1)   $tmp = $bk; else $tmp = $ad;
			
			if (!$isDetail){
				if (@$r->req_reason!='') $tmp.= '<br>'.$r->req_reason;
			}
			
		}else{							//rule was not applied, checking if bot.
			$tmp = $ad;
			if ( (@$r->bot_id > 0 || $r->bot_spoofing==1)
				&& @$r->recon_status==99){ 
				$tmp = $bk; 
				if ($r->is_blocked==0) $tmp = $nn;
			}
		}
		
		if (!$isDetail){
			if ($tmp!=$nn && $tmp!=''){
				$ft = self::getFilterHtml('filter_is_blocked',@$r->is_blocked);
				$tmp = $ft . $bn . $tmp;
			}
		}else{
			if (substr($tmp,0,strlen($nn))==$nn){
				$tmp = str_ireplace($nn,'',$tmp);
			}else{
				if ($tmp!='') $tmp = ' - '.$tmp;
			}
		}
		
		if (@$r->recon_status==0 || @$r->recon_status==19) $tmp = $nn;
		
		return $tmp;
	}
	
	public static function botStatus(&$r){
		$str = $r->status_text;
		$btname = ucfirst(@$r->bot_name);
		if ($btname!='' || @$r->bot_spoofing==1){
			if (!EV_SECUWATCH_IS_PRO){
				if ($btname!=''){
					if ( $r->is_bad == 1){
						$str = 'Bad Bot';
					}else{
						$str = 'Unverified';
					}
				}
			}else{
				if (@$r->bot_spoofing==1){
						$str = 'Unverified';
				}else{
					if ($btname!=''){
						if ($r->is_bad==1){
							$str = 'Unwanted Bot';
						}else{
							$str = 'Verified Bot';
						}
					}
				}
			}
		}
		return $str;
	}
	
	public static function botShow(&$r, $isDetail=false){
		$tmp = '';
		$btname = ucfirst( @$r->bot_name );
		//echo $btname . '<hr>';
		$more = ''; $moreD = ''; $botInfoIcon='';
		if ($btname!='' || @$r->bot_spoofing==1){
			if (!EV_SECUWATCH_IS_PRO){
				if ($btname!=''){
					if ($r->is_bad==1){
						$title = 'This looks like an unwanted bad bot. Should be blocked.';
					}else{
						$title = 'This visitor says that it is a good '.$btname
							.' bot, but it cannot be trusted until it has been verified. You need Pro Version to automatically verify good bots.';
					}
					$botInfoIcon = ' <span class="icon-info small" title="'.$title.'"></span>';
					$more = '" title="'.$title.'" style="color: orange;"';
					$moreD= '<span style="color: orange;">'.$title.'</span>';
				}
			}else{
				if (@$r->bot_spoofing==1){
						$btname = 'Spoofing';
						$title = 'Bot is not verified. It appears to be a spoofing attempt. Must be blocked and it is.';
						$more = '" title="'.$title.'" style="color: red;"';
						$moreD= '<span style="color: red;">'.$title.'</span>';
				}else{
					if ($btname!=''){
						if ($r->is_bad==1){
							$title = $btname. ' is possibly an unwanted bot. It is blocked by default.';
							$more = '" title="'.$title.'" style="color: orange;"';
							$moreD= '<span style="color: orange;">'.$title.'</span>';
						}else{
							$title = $btname. ' is verified to be a good bot. However, you can still block it if you like.';
							$more = '" title="'.$title.'" style="color: green;"';
							$moreD= '<span style="color: green;">'.$title.'</span>';
						}
					}
				}
			}
			
			if ($isDetail){
				$tmp .= '<span id="evsw_dtl_bot_name_'.$r->id.'">'.$moreD.'</span>';
			}else{
				$ft = '';
				if ($r->bot_id>0){
					$ft = self::getFilterHtml('filter_bot_id',@$r->bot_id);
				}elseif ($r->bot_spoofing>0){
					$ft = self::getFilterHtml('filter_bot_spoofing',@$r->bot_spoofing);
				}
				$tmp .= '<span id="evsw_list_bot_name_'.$r->id.'" '.$more.'>'. $ft .$btname.'</span>';
			}
			if (!EV_SECUWATCH_IS_PRO){
				$tmp .= $botInfoIcon;
				if ($r->is_bad==0){
					$tmp.='<br><a class="btn btn-danger btn-small">Verify (PRO Only)</a>';
				}else{
					$tmp.='<br><a class="btn btn-danger btn-small">Block (PRO Only)</a>';
				}
			}
			$tmp .= '<br>';
		}

		return $tmp;
	}
	
	public static function getIframePopJs(){
		$js = '
			<link rel="stylesheet" href="'.JURI::root().'media/system/css/modal.css" type="text/css" />
			<script type="text/javascript" src="'.JURI::root().'media/system/js/modal.js"></script>

			<script type="text/javascript">
					window.addEvent("domready", function() {

						SqueezeBox.initialize({});
						SqueezeBox.assign($$(\'a.modal\'), {
												parse: \'rel\'
											});
					});
			  </script>
						';
		return $js;
	}
	
	public static function getIframeCode($url, $text="", $id="", $rid=0, $moreClass=''){
		if ($rid > 0){
			$h = '<a id="'.$id.'" href="#" onclick="jQuery(\'#evsw_rql_md_'.$rid.'\').get(0).click();">'.$text.'</a>';
		}else{
			$h = '<a id="'.$id.'" rel="{handler: \'iframe\', size: {x: jQuery(window).width() - 100, y: jQuery(window).height() - 100}}" 
					href="'.$url.'" class="modal'.$moreClass.'">
					'.$text.'
					</a>
					';
		}
		return $h;
	}

	static function strToHex($string){
		$hex = '';
		for ($i=0; $i<strlen($string); $i++){
			$ord = ord($string[$i]);
			$hexCode = dechex($ord);
			$hex .= substr('0'.$hexCode, -2);
		}
		return strToUpper($hex);
	}	


	public static function hexToStr($hex){
		$string='';
		for ($i=0; $i < strlen($hex)-1; $i+=2){
			$string .= chr(hexdec($hex[$i].$hex[$i+1]));
		}
		return $string;
	}	
	
	public static function evContactFooter(){
		//
	}

	public static function geneLinkTip($text,$val1,$link,$val2){
		?>
					<td>
						<span class="editlinktip hasTip" title="<?php echo JText::_( $text );?>::<?php echo $val1; ?>">
						<a href="<?php echo $link; ?>">
							<?php echo $val2; ?></a> </span>
					</td>		
		<?php
	}
	
	public static function genRow($val,$align='',$maxChar=0, $tdMore=''){
		if($maxChar>0 && strlen($val)>$maxChar ) $val=substr($val,0,$maxChar).'...';
		
		if ($align!='') $align='style="text-align:'.$align.';" ';
		echo '<td '.$align . $tdMore .' >'.$val.'</td>';
	}
	
	public static function geneNavChecked($pageNav,$i,$checked, $id=0){
		?>
					<td>
						<?php 
							if ($id >0){
								echo $id; 
							}else{
								echo $pageNav->getRowOffset( $i ); 
							}
						?>
					</td>
					<td>
						<?php echo $checked; ?>
					</td>
		<?php
	}
	
	public static function geneFooter($pageNav,$cols, $tbodyId="adminFormTBody"){
		?>
				</tr>
			</thead>
			<tfoot>
				<tr>
					<td colspan="<?php echo $cols; ?>">
						<?php echo $pageNav->getLimitBox() . ' <span style="float:right">'
							. $pageNav->getListFooter() . '</span>'; ?>
					</td>
				</tr>
			</tfoot>
			<tbody id="<?php echo $tbodyId ?>">		
		<?php
	}
	
	public static function geneHeader(&$rows, &$lists, $fields, $component, $srHead='#', $moreAction=''){
		JHTML::_('behavior.tooltip');
		$act = 'index.php?option='.$component;
		if ($moreAction!='') $act = $moreAction;
		?>
		<form action="<?php echo $act ?>" method="post" name="adminForm" id="adminForm">

			<?php self::_searchResetEtc($component, $lists, $fields); ?>

			<table class="adminlist table table-striped">
			<thead>
				<tr>
					<?php if ($srHead!='^'){ ?>
					<th width="10" style="text-align:right;" >
						<?php echo JText::_( $srHead ); ?>
					</th>
					<?php } ?>
					
					<th width="10" class="title">
						<?php 
						if (version_compare(JVERSION,'3.1.0','>=')){
							echo JHtml::_('grid.checkall'); 
						}else{ ?>					
							<input type="checkbox" name="toggle" value="" onclick="checkAll(<?php echo count($rows); ?>);" />
						<?php 
						} ?>							
					</th>					
		<?php
	}
	
	public static function _searchResetEtc($component,&$lists,$fields){
		$h='';$h2='';
		
		$act = 'index.php?option='.$component;
		if (count($fields)>0){
			foreach ($fields as $field){
				$h.= $lists['filter_'.$field];
				$h2.="this.form.getElementById('"."filter_".$field."').value='';\n";
			}
		}
		$h.=@$lists['state'];
	
		?>
		<table>
		<tr>
			<td align="left" width="100%">
				<?php echo JText::_( 'COM_EV_SECUWATCH_BE_GENE_FILTER_LBL' ); ?>:
				<input type="text" name="search" id="search" value="<?php echo $lists['search'];?>" class="text_area" onchange="document.adminForm.submit();" />
				<button style="margin-top:-9px" onclick="this.form.submit();"><?php echo JText::_( 'COM_EV_SECUWATCH_BE_GENE_GO_LBL' ); ?></button>
				<button style="margin-top:-9px" onclick="document.getElementById('search').value='';
					<?php echo $h2; ?>
					document.adminForm.action = '<?php echo $act; ?>';
					document.adminForm.limitstart.value=0;
					this.form.submit();"><?php echo JText::_( 'COM_EV_SECUWATCH_BE_GENE_RESET_LBL' ); ?></button>
			</td>
			<td nowrap="nowrap">
				<?php
				//this.form.getElementById('filter_state').value='';
				echo $h;
				?>
			</td>
		</tr>
		</table>
		<?php
	}
	
	public static function delGene( $cid, $tbl, $redLink ){
		$mainframe = JFactory::getApplication();

		// Check for request forgeries
		JSession::checkToken() or jexit( 'Invalid Token' );
		JArrayHelper::toInteger($cid);

		if (count( $cid )) {
			$cids = implode( ',', $cid );

			$query = 'DELETE FROM '.$tbl
				. ' WHERE id IN ( '. $cids .' )'
				;

			self::doQuery( $query );
		}

		//
		$mainframe->redirect( $redLink );
	}	
	
	public static function entryFormsFooter($option, &$row){
		?>
		<input type="hidden" name="option" value="<?php echo $option; ?>" />
		<input type="hidden" name="id" value="<?php echo $row->id; ?>" />
		<input type="hidden" name="cid[]" value="<?php echo $row->id; ?>" />
		<input type="hidden" name="task" value="" />
		<?php echo JHTML::_( 'form.token' ); ?>
		<?php
	}

	public static function geneUserState(&$mainframe, $option, $task, &$lists, $fields, &$where_filter ){
		$where_filter='';
		foreach ($fields as $field){
			$ar['filter_'.$field]	= $mainframe->getUserStateFromRequest( $option.$task.'filter_'.$field,'filter_'.$field,'','');
			//echo 'filter_'.$field . '='. $ar['filter_'.$field].'<hr/>';
			
			if ($ar['filter_'.$field]!='') 
				$where_filter .= " AND $field = '".$ar['filter_'.$field]."' ";
		}
		return $ar;
	}
	
	public static function geneFiltersEtc(&$mainframe, $option, $task, &$lists, $orderField='', $ordDir='ASC' ){
		
		$tmp = $mainframe->getUserStateFromRequest( $option.$task.'filter_order'
					,'filter_order', 	$orderField,	'cmd' );
		$lists['order']		= $tmp;
		$ar[] = $tmp;
		
		$tmp = $mainframe->getUserStateFromRequest( $option.$task.'filter_order_Dir'
					,'filter_order_Dir',	$ordDir,	'word' );
		$lists['order_Dir']	= $tmp;
		$ar[] = $tmp;
		
		//$tmp = $mainframe->getUserStateFromRequest( $option.$task.'filter_state', 		'filter_state', 	'',				'word' );
		//$lists['state']	= JHTML::_('grid.state',  $tmp );
		$tmp = '';
		$ar[] = $tmp;

		$ar[] = $mainframe->getUserStateFromRequest('global.list.limit', 'limit', 100, 'int');
		$ar[] = $mainframe->getUserStateFromRequest($option.$task.'.limitstart', 'limitstart', 0, 'int');

		$tmp = $mainframe->getUserStateFromRequest( $option.$task.'search', 			'search', 			'',				'string' );
		$lists['search']= $tmp;		
		$ar[] = $tmp;
		
		return $ar;
	}
	
	public static function allRecsFormsFooter($option, $task, &$lists){
		?>

		<input type="hidden" name="option" value="<?php echo $option; ?>" />
		<input type="hidden" name="task" value="<?php echo $task; ?>" />
		<input type="hidden" name="boxchecked" value="0" />
		<input type="hidden" name="filter_order" value="<?php echo $lists['order']; ?>" />
		<input type="hidden" name="filter_order_Dir" value="<?php echo $lists['order_Dir']; ?>" />
		<?php echo JHTML::_( 'form.token' ); ?>
		
		<?php
	}

	static function sendRequestToCheckThisRequest( $token=0 ){
		$url = JURI::root() . 'index.php';
		
		//x $data= 'option=com_ev_secuwatch&view=examine_this_request&recon_token='.$token;
		$data= 'option=com_ev_secuwatch&tmpl=component&view=examine_this_request';
		
		self::getCurl($url, true, $data);
	}
		
	static function getCurl($url, $isPost=false, $postData=''){
		$ch = curl_init();

		curl_setopt($ch,CURLOPT_URL, $url);
		
		if ($isPost){
			curl_setopt($ch,CURLOPT_POST, true );
			curl_setopt($ch,CURLOPT_POSTFIELDS, $postData);
		}
		
		curl_setopt($ch,CURLOPT_USERAGENT,'Mozilla/5.0 (Windows NT 6.0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/49.0.2623.112 Safari/537.36');
		curl_setopt($ch,CURLOPT_FOLLOWLOCATION,TRUE);
		curl_setopt($ch, CURLOPT_SSL_VERIFYHOST, 0);
		curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, 0);
		curl_setopt($ch, CURLOPT_REFERER, JURI::root());
		curl_setopt($ch, CURLOPT_RETURNTRANSFER , true);

		//execute post
		$content  = curl_exec($ch);

		//close connection
		curl_close($ch);
		
		return $content;
	}
		
	public static function showOrderCol(&$row, &$rows, &$pageNav, $i){
		$ordering =  true;	
		?>
			<td class="order" colspan="2">
				<span><?php echo $pageNav->orderUpIcon( $i, ($row->position == @$rows[$i-1]->position), 'orderup', 'Move Up', $ordering ); ?></span>
				<span><?php echo $pageNav->orderDownIcon( $i, $n, ($row->position == @$rows[$i+1]->position),'orderdown', 'Move Down', $ordering ); ?></span>
				<?php $disabled = $ordering ?  '' : 'disabled="disabled"'; ?>
				<input type="text" name="order[]" size="5" value="<?php echo $row->ordering; ?>" <?php echo $disabled ?> class="text_area" style="text-align: center" />
			</td>		
		<?php
	}
	
	public static function simple_input( $fieldname, $val, $caption, $defaVal='', $size=10, $max=255, $tip_td=''
				, $tip_td2='', $inp_type='', $trStr='', $tdStr='', $extra_attribs='' ){
		
		if (($val=='' || $val==0) && $defaVal!='')  $val=$defaVal;
		//echo '!'.$val.'!'.$defaVal.'<hr/>';
		?>
		<tr <?php echo $trStr ?> >
			<td class="key">
				<label for="<?php echo $fieldname ?>">
					<?php echo JText::_( $caption ); ?>:
				</label>
			</td>
			<td <?php echo $tdStr ?> >
				<?php if ( $inp_type == 'textarea' ){ ?>
					<textarea name="<?php echo $fieldname ?>" id="<?php echo $fieldname ?>" rows="<?php echo $size ?>" cols="<?php echo $max ?>" class="inputbox" <?php 
							echo $extra_attribs ?> ><?php echo $val; ?></textarea>
				<?php }else{ ?>
					<input class="inputbox" type="text" name="<?php echo $fieldname ?>" id="<?php echo $fieldname ?>" size="<?php echo $size ?>" maxlength="<?php echo $max ?>" value="<?php echo $val; ?>" <?php 
							echo $extra_attribs ?> title="<?php echo JText::_( $caption ); ?>" />
				<?php } 
				if ( $tip_td2!='' ) 
					echo self::helpTip2($tip_td2); 
				?>
			</td>
			<?php
			if ( $tip_td!='' ) {
				echo '<td> '. self::helpTip($tip_td) .'</td>';
			}
			?>
		</tr>

		<?php 
	}
	
	public static function input_date( $fieldname, $val, $caption, $format='%Y-%m-%d %H:%M:%S' ){
		?>
		<tr>
			<td class="key">
				<label for="<?php echo $fieldname ?>">
					<?php echo JText::_( $caption ); ?>:
				</label>
			</td>
			<td>
				<?php echo JHTML::_('calendar', $val, $fieldname, $fieldname, $format); ?>
   			</td>
		</tr>
		<?php
	}
	
	public static function helpTip( $tip ){
		$h  = '<td style="color:grey" ><small><i>'.$tip.'</i></small></td>';

		echo $h;
	}

	public static function helpTip2( $tip, $color="grey" ){
		$h  = '<div style="padding-bottom:15px; color:'.$color.'" ><small><i>'.$tip.'</i></small></div>';

		return $h;
	}
	
	public static function grid_heading( $heading, $field, &$lists, $td_extra_html='', $th_extra='' ){
		$task	= self::getJInputVar('task','');
		
		?>
		<th class="title" <?php echo $th_extra; ?> >
			<div <?php echo $td_extra_html; ?>>
			<?php echo JHTML::_('grid.sort', $heading, $field, @$lists['order_Dir'], @$lists['order'], $task ); ?>
			</div>
		</th>
		<?php
	}

	public static function list_row2( &$list, $fieldname, $caption, $tip='', $tip_td='', $tdExtra='', $trStr='' ){
		?>
		<tr <?php echo $trStr; ?> >
			<td class="key" <?php echo $tdExtra; ?> >
				<label for="<?php echo $fieldname; ?>">
					<?php echo JText::_( $caption ); ?>:
				</label>
			</td>
			<td>
				<?php echo $list; ?>
				<?php echo $tip; ?>
			</td>
			<?php if ( $tip_td!='' ) echo '<td> '. self::helpTip($tip_td) .'</td>'; ?>
		</tr>
		<?php
	}
	
	public static function list_row( &$lists, $fieldname, $caption, $tip='', $tip_td='', $tdExtra='', $trStr='' ){
		?>
		<tr <?php echo $trStr; ?> >
			<td class="key" valign="top" <?php echo $tdExtra; ?> >
				<label for="<?php echo $fieldname; ?>">
					<?php echo JText::_( $caption ); ?>:
				</label>
			</td>
			<td>
				<?php echo $lists[$fieldname]; ?>
				<?php echo $tip; ?>
			</td>
			<?php if ( $tip_td!='' ) echo '<td> '. self::helpTip($tip_td) .'</td>'; ?>
		</tr>
		<?php
	}

	//
	public static function recsInTable( $table, $query='' ){
		if ( $query == '' ) $query = "SELECT COUNT(*) FROM $table ";
		return getResult( $query );
	}

	public static function gene_dd( $fieldname, &$oparray, &$oparrayVal, $hint='', $selected_val='', $addJs=false ){

		if ( $hint != '' ){
			$arr[] = JHTML::_('select.option',  '', '- '. JText::_( $hint ) .' -' );
		}

		for ($i=0, $n=count($oparray); $i < $n; $i++) {
			$arr[] = JHTML::_('select.option',  $oparray[$i], $oparrayVal[$i] );
		}

		$javascript = '';
		if ( $addJs ) {
			$javascript = 'onchange="document.adminForm.submit();"';
		}

		return JHTML::_('select.genericlist', $arr, $fieldname, 'class="inputbox" size="'. 1 .'" '. $javascript, 'value', 'text', $selected_val );
	}

	public static function _getHtmlRadio( $type, $fieldname, $dummy, $val, $fid='' ){
		if ($fid=='') $fid=$fieldname;
		
		if ( self::_isJoomla16() ){
			$html = '
			<fieldset class="radio btn-group btn-group-yesno" id="jform_type_'.$fieldname.'">
				<input type="radio" '.($val==0?' checked="checked" ':'').' value="0" name="'.$fieldname.'" id="'.$fid.'0">
				<label for="'.$fid.'0">No</label>
				<input type="radio" '.($val>0?' checked="checked" ':'').' value="1" name="'.$fieldname.'" id="'.$fid.'1">
				<label for="'.$fid.'1">Yes</label>
			</fieldset>';
			return $html;
		}else{
			return JHTML::_('select.booleanlist',  $fieldname, '', @$val );
		}
	}

	//joomla 1.6 compatibility
	public static function _isJoomla16(){
		$version = new JVersion;
		$joomla = $version->getShortVersion();

		$v = substr($joomla,0,3);
		if( $v >= '1.6' ) return true;
	}

	public static function listFromTable( $query, $hint, $fieldname, $selected_value, $size = 1, $javascript='', $bval = '0', $extra_items=array() ){
		$mul='';
		if ( $size > 1 ) {
			$mul = ' multiple="multiple" ';
		}

		$rows = self::getRows( $query );

		$items = array();
		if ( $hint != '' ){
			$items[] = JHTML::_('select.option',  $bval, '- '. JText::_( $hint ) .' -' );
		}

		if (count($extra_items)>0) $items = array_merge( $items, $extra_items );
		if (count($rows)>0)	$items = array_merge( $items, $rows );

		$list = JHTML::_('select.genericlist', $items, $fieldname , 'class="inputbox" size="'. $size .'" '.$mul.' '. $javascript, 'value', 'text', $selected_value );
		return $list;
	}
	
	public static function getJInputVar($var, $defa=''){
		$val = JFactory::getApplication()->input->request->get($var,$defa);	
		return $val;
	}

	public static function getVarJeStr( $var, $isRaw=false ){
		if ($isRaw){
			$v = JFactory::getApplication()->input->request->get($var,'','RAW');
		}else{
			$v = JFactory::getApplication()->input->request->get($var,'');
		}
		
		$v = self::addSlashesJE($v);
		return $v;
	}

	public static function getVarJeNum( $var ){
		$v = self::getJInputVar($var,0);
		return $v;
	}

	public static function getArrJe( $var, $to_csv=false ) {
		$arr = self::getJInputVar($var,array());

		if ( $to_csv ) {
			$arr = implode(",",$arr);
		}
		return $arr;
	}

	public static function lastInsertedId(){
		$db	= JFactory::getDBO();
		return $db->insertid();
	}

	public static function recsAffected(){
		$db	= JFactory::getDBO();
		return $db->getAffectedRows();
	}

	public static function getResult( $query ){
		$db	= JFactory::getDBO();

		$db->setQuery( $query );
		return $db->loadResult();
	}

	public static function doQuery( $query ){
		$db	= JFactory::getDBO();
		$db->setQuery( $query );

		return $db->query();
		// if (!$db->query()) {
			// echo "<script> alert('".$db->getErrorMsg(true)."'); window.history.go(-1); </script>\n";
		// }
	}

	public static function getRows( $query, $limitStart=0, $recs=0 ){
		$db	= JFactory::getDBO();

		if ( $recs > 0 ) {
			$db->setQuery( $query, $limitStart, $recs );
		}else{
			$db->setQuery( $query );
		}

		$rows = $db->loadObjectList();
		return $rows;
	}

	public static function getRow( $query ){
		$rows = self::getRows( $query );
		$row  = '';
		if ( count( $rows ) > 0 ) $row  = $rows[0];
		return $row;
	}

	public static function je_showdate($str_date){
		if ( substr($str_date,0,10)=='0000-00-00' ) return '';
		return self::get_month(substr($str_date,5,2)).' '.substr($str_date,8,2).', '.substr($str_date,0,4);
	}

	public static function get_month( $month_no ){
		if ( $month_no == 0 ) return '';
		$month_no--;

		$ma = array(
			"Jan"
			,"Feb"
			,"Mar"
			,"Apr"
			,"May"
			,"Jun"
			,"Jul"
			,"Aug"
			,"Sep"
			,"Oct"
			,"Nov"
			,"Dec"
				);

		return $ma[$month_no];
	}

	public static function getPubWhere( $filter_state ){
		$where = '';
		if ( $filter_state ) {
			if ( $filter_state == 'P' ) {
				$where .= ' AND cd.published = 1';
			} else if ($filter_state == 'U' ) {
				$where .= ' AND cd.published = 0';
			}
		}
		return $where;
	}

	public static function addSlashesJE( $str ){
		//if(get_magic_quotes_gpc()){
		if(get_magic_quotes_runtime()){
			return $str;
		}else{
			return addslashes($str);
		}
	}

	public static function stripSlashesJE( $str ){
		if(get_magic_quotes_gpc()){
			return $str;
		}else{
			return stripSlashes($str);
		}
	}
	
	public static function is_debug(){
		$debugje = self::getJInputVar('debugje','');
		if ($debugje=='evsw' || $debugje=='evsw2') return true;
	}

	public static function debugje_dump($header,$obj){
		$debugje = self::getJInputVar('debugje','');

		$str = $header . '---------------'. print_r($obj,true);
		if ($debugje=='evsw'){
			echo '<pre>'.$str . '</pre>'.'<hr>';
		}elseif ($debugje=='evsw2'){
			self::addToLog($str);
		}
	}
	
	public static function debugje($str){
		$debugje = self::getJInputVar('debugje','');
		
		if ($debugje=='evsw' || $debugje=='evsw2'){
			if (self::$tblPfx==''){
				self::$tblPfx = self::cmGetConfVal('dbprefix');
			}
			
			$str = str_ireplace('#__',self::$tblPfx,$str);
			
			if ($debugje=='evsw'){
				echo $str . '<hr>';
				
			}elseif ($debugje=='evsw2'){
				self::addToLog($str);
			}
		}
	}

	function addToLog($str){
		$fh = @fopen(JPATH_PLUGINS."/system/ev_secuwatch/"."log.txt", 'a');
		$str = "\n".date('Y-m-d H:i:s')."\n".$str."\n";
		@fwrite($fh, $str);
		@fclose($fh);	
	}	

	static function cmGetConfVal($key){
		$conf = JFactory::getConfig();
		if (version_compare(JVERSION,'3.0.0','>=')){
			$key=str_ireplace('config.','',$key);
			$r = $conf->get($key);
		}else{
			$r = $conf->getValue($key);
		}
		return $r;
	}

	public static function getRowPz($q, $fa, $tbl, $where='', $ord=''){
		$rows = self::getRowsPz($q, $fa, $tbl, $where, $ord, 1);
		$row  = '';
		if ( count( $rows ) > 0 ) $row  = $rows[0];
		return $row;
	}	
	
	static function getRowsPz($fa, $tbl, $tblAlias='', $where='', $ord='', $limit=0){
		$db = JFactory::getDbo();
		$q = $db->getQuery(true);

		$q->select($db->quoteName($fa));
		
		if ($tblAlias==''){
			$q->from($db->quoteName($tbl));
		}else{
			$q->from($db->quoteName($tbl, $tblAlias));
		}
		
		if ($where!='')
			$q->where($where);
			
		if ($ord!='') $q->order('ordering ASC');
		if ($limit>0) $q->setLimit($limit);
 
		$db->setQuery($q);
		
		if (self::is_debug())
			self::debugje('getRow^sPz: $db->getQuery() = '. $db->getQuery() );
		
		$rows = $db->loadObjectList();
		return $rows;
	}
	
}
?>