<?php
/**
* @package EverLive.net Ev Security Watch for Joomla 3.x
* @version $Id: 100 2017-28-02 $
* @author EverLive.net
* @copyright (C) 2017 EverLive.net. All rights reserved.
* @license GNU/GPLv3 http://www.gnu.org/licenses/gpl-3.0.html
**/

// no direct access
defined( '_JEXEC' ) or die( 'Restricted access' );

if (!defined('DS')) define('DS','/');

jimport( 'joomla.filesystem.folder' );
jimport( 'joomla.filesystem.file' );
if(!class_exists('JURI'))
{
	jimport( 'joomla.environment.uri' );
}

class Com_ev_secuwatchInstallerScript{	
	function postflight($type, $parent){
		_installComplete_scwt();
	}
}

function com_install()
{
	_installComplete_scwt();
}

//installation
function _isTableExists_scwt( $tbl ){
	$conf = JFactory::getConfig();
	
	//$tbl = $conf->getValue('config.dbprefix').$tbl;
	if (version_compare(JVERSION,'3.0.0','>=')){		
		$tbl = $conf->get('dbprefix').$tbl;
	}else{
		$tbl = $conf->getValue('config.dbprefix').$tbl;
	}	
	
	$s = " show tables like '$tbl' ";
	//echo $s.'!';
	if ( getResult( $s ) != '' ) return true;
}

function _installComplete_scwt(){
	$q = "CREATE TABLE IF NOT EXISTS #__ev_secuwatch_config (
  cfg_id int(11) NOT NULL AUTO_INCREMENT,
  config text,
  PRIMARY KEY (cfg_id)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
		";
	doQuery_scwt($q);

	$q = "insert ignore into #__ev_secuwatch_config values (1,'') ";
	doQuery_scwt($q);
	
	$q = "CREATE TABLE IF NOT EXISTS #__ev_secuwatch_bots (
  bot_id int(11) NOT NULL AUTO_INCREMENT,
  bot_name varchar(50) DEFAULT NULL,
  bot_verify_url varchar(255) DEFAULT NULL,
  is_bad int(11) DEFAULT '0',
  PRIMARY KEY (bot_id),
  UNIQUE KEY bot_name (bot_name)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
		";
	doQuery_scwt($q);
	
	//
	$q = "insert ignore into #__ev_secuwatch_bots values 
(1,'googlebot','googlebot.com',0),
(2,'bing','bing.com',0),
(3,'yahoo','yahoo.com',0),
(4,'duckduckbot','duckduckgo.com',0),
(5,'baiduspider','baidu.com',0),
(6,'yandex','yandex.com',0),
(7,'sogou','sogou.com',0),
(8,'exabot','exabot.com',0),
(9,'facebook','facebook.com',0),
(10,'alexa','alexa.com',0),
(12,'msnbot','msn.com',0),
(17,'adidxbot','bing.com',0),
(18,'garlik','',1);
";
	doQuery_scwt($q);
	
	//
	$q = "CREATE TABLE IF NOT EXISTS #__ev_secuwatch_requests (
  id int(11) NOT NULL AUTO_INCREMENT,
  is_admin int(11) DEFAULT '0',
  date_time datetime DEFAULT NULL,
  ip varchar(50) DEFAULT NULL,
  request_url text,
  session_id varchar(255) DEFAULT NULL,
  user_id int(11) DEFAULT '0',
  more_details text,
  token decimal(20,10) DEFAULT '0.0000000000',
  recon_status int(11) DEFAULT '0' COMMENT '0 is waiting. 10 is Normal, 19 check again, 99 is potentially dangerous',
  recon_details text,
  add_modif_time timestamp NULL DEFAULT CURRENT_TIMESTAMP,
  bot_id int(11) DEFAULT '0',
  bot_spoofing int(11) DEFAULT '0',
  is_404 int(11) DEFAULT '0',
  applied_rule_id int(11) DEFAULT '0',
  is_blocked int(11) DEFAULT '0',
  is_js tinyint(4) DEFAULT '0' COMMENT 'is javascript enabled?',
  req_reason varchar(255) DEFAULT NULL,
  PRIMARY KEY (id)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
		";
	doQuery_scwt($q);

	//
	$q = "CREATE TABLE IF NOT EXISTS #__ev_secuwatch_ips (
  ip varchar(255) NOT NULL,
  country_code varchar(10) DEFAULT NULL,
  country_name varchar(255) DEFAULT NULL,
  city varchar(255) DEFAULT NULL,
  latitude float(12,6) DEFAULT '0.000000',
  longitude float(12,6) DEFAULT '0.000000',
  region_code varchar(255) DEFAULT NULL,
  region_name varchar(255) DEFAULT NULL,
  zip_code varchar(50) DEFAULT NULL,
  metro_code varchar(50) DEFAULT NULL,
  time_zone varchar(50) DEFAULT NULL,
  add_modif_time timestamp NULL DEFAULT CURRENT_TIMESTAMP,
  PRIMARY KEY (ip)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
		";
	doQuery_scwt($q);	
	
	//
	$q = "CREATE TABLE IF NOT EXISTS #__ev_secuwatch_rules (
  rule_id int(11) NOT NULL AUTO_INCREMENT,
  rule_ip varchar(50) DEFAULT NULL,
  rule_country_code varchar(10) DEFAULT NULL,
  rule_request_url text,
  rule_bot_id int(11) DEFAULT '0',
  rule_action int(11) DEFAULT NULL COMMENT '10 allow, 99 block',
  rule_duration_mins int(11) DEFAULT NULL COMMENT 'n minutes, 99 for forever',
  rule_created_by int(11) DEFAULT '0' COMMENT '0 manual, 10 auto, 100 auto by everlive.net live',
  rule_time timestamp NULL DEFAULT CURRENT_TIMESTAMP,
  published int(11) DEFAULT '1',
  subseq_ip_action_mins int(11) DEFAULT '0',
  parent_rule_id int(11) DEFAULT '0',
  reason varchar(255) DEFAULT NULL,
  rule_bot_spoofing int(11) DEFAULT '0',
  PRIMARY KEY (rule_id)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
		";
	doQuery_scwt($q);	
	
	//
	if (!class_exists('EvGeneCompoHelperSW')){
		include_once( 'admin/helper.php' );
	}
	EvGeneCompoHelperSW::loadBotsInTable();

	//
	if (version_compare(JVERSION,'3.0.0','<')){
		require_once( JPATH_ADMINISTRATOR.'/components/com_ev_secuwatch/install.ev_secuwatch-upgrade.php' );
	}else{
		require_once( 'admin/install.ev_secuwatch-upgrade.php' );
	}
	
	_installOk_scwt();
	_showInstall_scwt();
}

function _showInstall_scwt(){
	$lang = JFactory::getLanguage(); 
	$lang->load('com_ev_secuwatch', JPATH_ADMINISTRATOR); 

	?>
	<style type="text/css">
	#ev-installer-left {
		float: left;
		padding: 10px;
		width:30%;	
	}

	#ev-installer-right {
		float: left;
		padding: 10px;
		width:60%;
	}

	</style>

	<div id="ev-installer-left">
		<a target="_blank" href="http://www.everlive.net/getting-started-cloud-backup.html">
			<img src="<?php echo JURI::root(); ?>administrator/components/com_ev_secuwatch/images/everlive2_300.png" alt="<?php echo JText::_('COM_EV_SECUWATCH_POSTINSTALL_JEEV'); ?>" />
		</a>
		<h3><a target="_blank" href="http://www.EverLive.net/joomla-extensions.html"><?php echo JText::_('COM_EV_SECUWATCH_POSTINSTALL_JEEV_ALL'); ?></a></h3>
	</div>
	<div id="ev-installer-right">
	<a target="_blank" href="<?php 
		echo JURI::base().'index.php?option=com_ev_secuwatch&task=watchlive';
		?>" class="btn btn-primary btn-large"><?php echo JText::_('COM_EV_SECUWATCH_POSTINSTALL_JEEV_POPUP_NOW') ?></a>
	<a target="_blank" href="http://www.everlive.net/joomla-extensions/43-joomla-security-watch.html" class="btn btn-primary btn-large"><?php echo JText::_('COM_EV_SECUWATCH_POSTINSTALL_JEEV_READ_GUIDE') ?></a>
	</div><br/><br/>
	<?php	
}

function _installOk_scwt(){
	$path =  dirname(__FILE__). '/sub_packages/plg_sys_ev_secuwatch/';
	//echo $path;
	
	$installer =  new JInstaller();
	$installer->install($path);
}

function doQuery_scwt( $query ){
	$db	= JFactory::getDBO();
	$db->setQuery( $query );

    //return $db->query();
	if (!$db->query()) {
		echo "<script> alert('".$db->getErrorMsg(true)."'); window.history.go(-1); </script>\n";
	}
}

