<?php
/**
* @package EverLive.net Ev Security Watch for Joomla 3.x
* @version $Id: 100 2017-28-02 $
* @author EverLive.net
* @copyright (C) 2017 EverLive.net. All rights reserved.
* @license GNU/GPLv3 http://www.gnu.org/licenses/gpl-3.0.html
**/

// no direct access
defined( '_JEXEC' ) or die( 'Restricted access' );

class ev_secuwatchController extends JControllerLegacy
{
	var $_isPro=false;
	var $_objProH = null;
	
	function __construct(){
		$fn = JPATH_ADMINISTRATOR.'/components/com_ev_secuwatch/ev_secuwatch_helper_pro.php';
		if (file_exists($fn)){
			require_once($fn);
			
			$this->_objProH = new EvSecuWatchHelperPro;
			$this->_isPro = true;
		}
		parent::__construct();
	}
	
	public function display($cachable = false, $urlparams = false){	}
	
	public function get_ip_info(){	//called via curl
		$this->fastReturn();	//only remark temporarily for debugging
		if (!$this->_isPro) die();
		
		$this->_objProH->getIpInfo();
		die();
	}
	
	private function fastReturn(){
		if ( EvGeneCompoHelperSW::is_debug()) return;
		
		//this is handling a background call. It will not return any output.
		header('Content-Length: 0');
		header('Connection: close');
		ob_end_flush();
		ob_flush();
		flush();
	}
	
	public function bot_rmt(){
		$this->fastReturn();	//only remark temporarily for debugging
		if (!$this->_isPro) return;
		$this->_objProH->bot_rmt();
		die();
	}
	
	public function examine_this_request(){
		EvGeneCompoHelperSW::debugje('examine_this_requ^est: Starting....');
		$this->fastReturn(); 	//only remark temporarily for debugging
		
		$q	 = "SELECT cd.*, ips.country_code
					FROM #__ev_secuwatch_requests cd
					LEFT JOIN #__ev_secuwatch_ips ips ON cd.ip = ips.ip
					WHERE (recon_status = 0 OR  recon_status = 19)
					";
		EvGeneCompoHelperSW::debugje('examine_this_requ^est: $q = '.$q);
		$rows = EvGeneCompoHelperSW::getRows($q);
		
		for($i=0;$i<count($rows);$i++){
			$row = $rows[$i];
			EvGeneCompoHelperSW::debugje('examine_this_requ^est: Checking Req ID='. $row->id );
			//EvGeneCompoHelperSW::debugje('examine_this_requ^est: $row = '.print_r($row,true) );
			EvGeneCompoHelperSW::debugje_dump('examine_this_requ^est: $row = ',$row );
			
			$status = 0;
		
			$md = EvGeneCompoHelperSW::mdReadFromDb( $row->more_details );
			EvGeneCompoHelperSW::debugje_dump('examine_this_requ^est: $md = ',$md );
			
			//if ($md[1]['is404'] == 1){
			if ($row->is_404==1){
				$status = 99;
			}else{
			}
		
			$bot_spoof = 0; $bot_id=0;$isBot = 0; $arrStatus=array(); $tmp = '';
			if ($this->_isPro){
				//check if allowed or denied
				//if ($this->_isPro){
					$arrStatus = $this->_objProH->detectPrevRules($row->ip, $row->request_url, $row->country_code);
					EvGeneCompoHelperSW::debugje_dump('examine_this_requ^est: $arrStatus = ',$arrStatus );
					
					if (@$arrStatus[0]>0){
						if (@$arrStatus[1]>0){
							$status = @$arrStatus[1]; //some rule has been applied
						}
					}
				//}
			
				if ($status==0){
					$bot_spoof = 0;
					list($bot_id,$isVerfied) = $this->_objProH->detectBot($row, $md, true);
					if ($isVerfied){
						$status = 10;
						$isBot = 2;
						EvGeneCompoHelperSW::debugje('examine_this_requ^est: Bot verified. $bot_id = '.$bot_id);

					}elseif ($bot_id!=0){  //if 0 then not a bot.
						$isBot = 1;
						$status = 99;
						if ($bot_id==-1){
							$bot_id=0;
							$bot_spoof = 1;
						}
					}else{
						//not a bot.
						$isBot = 0; 
					}
				}
				
				if (@$arrStatus[2]){	//if subseq rule added.
					//forking a request to clear deny rules if this is a good bot.
					$this->_objProH->init_bot_rmt($row);	
				}
				//pro version
		
				$tmp = '';
				if (@$arrStatus[0]>0){
					$tmp .= ", applied_rule_id = '". @$arrStatus[0] ."'";
				}
				$req_reason=''; if (@$arrStatus[3]!='') $req_reason=$arrStatus[3];
				if ($bot_id==0 && @$arrStatus[4]>0) $bot_id=$arrStatus[4];
				$bot_spoofing=0; if (@$arrStatus[5]>0) $bot_spoofing=$arrStatus[5];
				
				if ($bot_spoof==1){
					$tmp .= ", bot_spoofing = '". $bot_spoof ."'";
				}
			}else{ 
				//free version.
				list($bot_id) = EvGeneCompoHelperSW::detectBotFree($row, $md);
			}		
			
			if ($status==0) $status=10; //all fine.
			$q	 = "UPDATE #__ev_secuwatch_requests 
						SET recon_status='$status' 
						, bot_id = '$bot_id'
						, req_reason = '$req_reason'
						, bot_spoofing = '$bot_spoofing'
						, add_modif_time = CURRENT_TIMESTAMP
						". $tmp ."
						WHERE id = '". $row->id ."'
						";
			EvGeneCompoHelperSW::doQuery($q);
		}
		
		$this->deleteReqLastN(1000);
		die();
	}
		
	private function deleteReqLastN($n){
		$q = "DELETE FROM #__ev_secuwatch_requests
			WHERE id NOT IN (
			  SELECT id
			  FROM (
				SELECT id
				FROM #__ev_secuwatch_requests
				ORDER BY id DESC
				LIMIT $n 
			  ) foo
			)";
		EvGeneCompoHelperSW::doQuery($q);

		if ($this->_isPro) $this->_objProH->cleanTables();
	}
}
