<?php
/**
* @package EverLive.net Ev Security Watch for Joomla 3.x
* @version $Id: 100 2017-28-02 $
* @author EverLive.net
* @copyright (C) 2017 EverLive.net. All rights reserved.
* @license GNU/GPLv3 http://www.gnu.org/licenses/gpl-3.0.html
**/

// no direct access
defined( '_JEXEC' ) or die( 'Restricted access' );
if (!defined('DS')) define('DS','/');

jimport( 'joomla.plugin.plugin' );

class plgSystemEv_secuwatch extends JPlugin
{
	var $_cm_isAdmin;
	var $_pluginUrlPath;
	var $_component;
	//var $_model;
	var $_isPro		= false;
	var $_objProH	= false;
	
	var $_installed = false;
	var $_token = '';
	var $_isExamReq=0;
	var $_selfServerReq=false;
	var $_isTrusted=false;
	var $_localDevServer=false;
	
	var $_op = '';
	var $_vu   = '';
	var $_tk  = '';
	var $_config=array();
	
	function __construct(& $subject, $config) {
		JError::setErrorHandling(E_ERROR, 'callback', array($this, 'Error404'));
		set_exception_handler(array($this, 'Error404'));
		
		$jInput = JFactory::getApplication()->input;
		$this->_op	= strtolower( $jInput->getCmd('option') );
		$this->_vu	= strtolower( $jInput->getCmd('view') );
		$this->_tk	= strtolower( $jInput->getCmd('task') );
		
		
		parent::__construct($subject, $config);
		//$this->loadLanguage();		
	}

	private function isAdmin(){
		$app = JFactory::getApplication();
		$b = $app->isAdmin();
		
		$this->_cm_isAdmin = $b;
		return $b;
	}

	private function initVars(){
		$this->_pluginUrlPath = JURI::root().'plugins/system/ev_secuwatch/';
		//if ( !$this->_cm_isAdmin ){
			$this->loadComponent();
			
			$fn = JPATH_ADMINISTRATOR.'/components/com_ev_secuwatch/ev_secuwatch_helper_pro.php';
			if (file_exists($fn)){
				require_once($fn);
				$this->_isPro = true;
				$this->_objProH = new EvSecuWatchHelperPro;
			}
		//}
		
		if (@$_SERVER['REMOTE_ADDR']==@$_SERVER['SERVER_ADDR']){
			$this->_selfServerReq = true;
		}

		if (@$_SERVER['REMOTE_ADDR']=='127.0.0.1' && @$_SERVER['HTTP_HOST']=='local-j351.com' ) 
					$this->_localDevServer=true;

		if ($this->_isPro){
			$this->_config = $this->_objProH->getConfig();
			if (!defined('EVSW__CFG_SECUKEY')) define('EVSW__CFG_SECUKEY',@$this->_config['basic']['evsw_secu_key']);
		}					
		
				
	}
	
	public function onAfterInitialise(){
		$this->isAdmin();
		$this->initVars();

		$this->jscall();
		$this->initExamineRequest();
	}

	public function onAfterRoute(){
		if ( !$this->_installed ) return;

		if ( $this->_cm_isAdmin ){
		}else{
		}
	}
	
	public function onAfterDispatch(){
	}
	
	public function onAfterRender(){
		if ( !$this->_installed ) return;
		
		$this->finalizeReq();
		if ( $this->_cm_isAdmin ){
		}else{
		}
		$this->addJsDetectionCode();
	}

	private function jscall(){
		if ($this->_op != 'com_ev_secuwatch') 	return;
		if ($this->_vu != 'jscall' )			return;
			
		$token = EvGeneCompoHelperSW::getTokenFromReq();
		EvGeneCompoHelperSW::debugje('jsc^all: $token = '.$token);
		
		$r 	   = EvGeneCompoHelperSW::getReqRecByToken($token);
		if (@$r->id>0){
			EvGeneCompoHelperSW::markJs($r->id);
			$session = JFactory::getSession();
			$session->set('evsw__is_js',1);
		}
		EvGeneCompoHelperSW::noCacheHeaders();
		die();
	}
	
	private function addJsDetectionCode(){
		if ($this->_isExamReq==1) return;
		if ($this->_isTrusted) return;

		$session = JFactory::getSession();
		if ($session->get('evsw__is_js',0)==1) return; //already checked and js is enabled.
		
		//$session->set('jscall_token',$this->_token);
		
		$url = JURI::root() . 'index.php?option=com_ev_secuwatch&tmpl=component&view=jscall&token='. $this->_token;
		$h = '';
		$h.= '<script type="text/javascript">
					try{
						var xhttp = new XMLHttpRequest();
						xhttp.open("GET", "'.$url.'", true);
						xhttp.send();
					}catch(e){}
			  </script>';
		$content  = JResponse::getBody();
		$content  = str_ireplace('</head>',$h.'</head>',$content);
		JResponse::setBody( $content );		
	}
	
	private function finalizeReq(){
		if ($this->_isExamReq==1) return;
		if ($this->_isTrusted) return;
		
		$row = $this->getReqRecByToken($this->_token); 	if (@$row->id<=0) return;
		
		if ($row->recon_status=='99' 
				&& (@$row->applied_rule_id > 0 || @$row->bot_id > 0 || @$row->bot_spoofing == 1) 
				){
			if ($this->_isPro){
				$this->_objProH->blockRequest($row->id, $row->applied_rule_id, @$row->bot_id);
			}
		}
	}
	
	public function Error404(&$error){
      	if ($error->getCode() == '404'){
			$row = $this->getReqRecByToken($this->_token); 	if (@$row->id<=0) return;
			
			$q	 = "UPDATE #__ev_secuwatch_requests SET recon_status=19 
						, is_404 = 1
						, add_modif_time = CURRENT_TIMESTAMP
						WHERE id = '". @$row->id ."' 
						";
			$this->doQuery($q);
			//			, more_details = '$md'
			
			EvGeneCompoHelperSW::sendRequestToCheckThisRequest( $this->_token );
		}
		
		$this->finalizeReq();

		$e = new RuntimeException($error->getMessage(), $error->getCode(), $error);
		JErrorPage::render($e);
		EvGeneCompoHelperSW::noCacheHeaders();			
	}
	
	private function getReqRecByToken($token){
		$db = JFactory::getDbo();
		$q	 = "SELECT * FROM #__ev_secuwatch_requests 
					WHERE ".$db->quoteName('token')." = '$token' ";
		$row = $this->getRow($q);
		return $row;
	}
	
	private function initExamineRequest(){
		$user = JFactory::getUser(); 
		if ( $this->_cm_isAdmin ){
			if ( $user->id > 0 ){
				$this->_isTrusted=true;
				return; //if logged in as admin then fine.
			}
		}

		$session = JFactory::getSession();

		if ($this->_op == 'com_ev_secuwatch'){ 
			if ( $this->_tk =='get_latest_reqs' ){
				if ( $this->_cm_isAdmin ){
					if ( $user->id <= 0 ){
						echo 'r10';
						die();
					}
				}			
				
			}elseif ( $this->_vu=='examine_this_request' || $this->_vu=='get_ip_info' 
								|| $this->_vu=='bot_rmt' || $this->_vu=='jscall'){
				$b=false;
				if ($this->_vu=='jscall'){
					if ( $this->_localDevServer ) $this->_selfServerReq=false; //consider non-local call when view is jscall.
					
					//check if this request code was sent by server to check js availability.
					$jscTk = EvGeneCompoHelperSW::getTokenFromReq();
					//echo $session->get('jscall_token','').'!';
					
					if ($session->get('jscall_token','')==$jscTk){
						$session->set('jscall_token','');
						$b=true; //request is genuine.
					}
				}
				if ($this->_selfServerReq || $b){
					$this->_isExamReq=1;
					return; //avoid cyclic redundancy
				}
			}
		}
						
		$d 		= date('Y-m-d H:i:s',time());
		$ip		= $_SERVER['REMOTE_ADDR'];
		
		$reqUrl	= $_SERVER['REQUEST_URI'];
		if($reqUrl=='/favicon.ico') return; //temporary fix
		
		$ar[] 	= $_SERVER;
		$ar[] 	= array(); //'is404' => 0
		
		//data for local working
		if ( $this->_localDevServer ) {
			$n = rand(0,5);
			//$n = 5;
			
			$localIps = array('45.116.232.18','24.244.95.103','68.180.230.163','198.67.22.11'
							,'64.237.56.125','131.253.27.171');
			$ip	= $localIps[ $n ];	//temporary.
			$localUAs = array('Mozilla/5.0 (compatible; M12bot/v1.4.7; http://mj12bot.com/)'
						,'Mozilla/5.0 (Windows NT 6.1; WOW64; rv:40.0) Gecko/20100101 Firefox/40.1'
						,'Mozilla/5.0 (compatible; Yahoo! Slurp; http://help.yahoo.com/help/us/ysearch/slurp)'
						,'Mozilla/5.0 (compatible; Googlebot/2.1; +http://www.google.com/bot.html)'
						,'Mozilla/5.0 (Windows NT 6.0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/49.0.2623.112 Safari/537.36'
						,'Mozilla/5.0 (compatible; SeznamBot/3.2; +http://napoveda.seznam.cz/en/seznambot-intro/)'
						);
			$ar[0]['HTTP_USER_AGENT'] = $localUAs[ $n ];
		}
		EvGeneCompoHelperSW::init_ip_info($ip);

		if ($this->_isPro){
			if ( $this->_cm_isAdmin && $user->id<=0){
				$url 	= JURI::getInstance()->toString();
				$ysk = @$this->_config['basic']['evsw_secu_key'];
				
				if (strpos($url,$ysk)!==false && $ysk!=''){
					$this->_objProH->unblockIP($ip);
					$app = JFactory::getApplication();
					$u 	 = JURI::root() . 'administrator/index.php';
					$app->redirect( $u );
					return;
				}
			}
		}
		
		//
		$md = EvGeneCompoHelperSW::mdMakeToSave($ar);
		
		$r      = time();
		$r2     = rand(1,999999999)/999999999;
		$r3     = rand(1,999999999)/999999999;
		$token	= $r + (float) $r2;
		$token .= substr(str_replace('.','',$r3).'000000',0,6) ;
		//die($token.'!');
		$this->_token = $token;
		
		$recon_status = 0; 

		$applied_rule_id=0; $is_blocked=0; $bot_id=0; $bot_spoofing = 0;
		//quick blocking. Right in the beginning.
		$blockNow=false; $req_reason='';
		if ($this->_isPro){	// && !$this->_cm_isAdmin
			$arrStatus = $this->_objProH->detectIpBlockQuick($ip);
			if (@$arrStatus[0]>0){
				if (@$arrStatus[1]==99){
					$blockNow=true;
					$recon_status=99;
					$applied_rule_id=$arrStatus[0]; $is_blocked=1;
					if (@$arrStatus[3]!='') $req_reason=$arrStatus[3];
					if (@$arrStatus[4]>0) 	$bot_id    =$arrStatus[4];					
					if (@$arrStatus[5]>0) 	$bot_spoofing = $arrStatus[5];
				}
			}
		}
		
		$is_js=0;
		if ($session->get('evsw__is_js',0)==1) $is_js=1;
		
		if (!$blockNow){
			$q = "INSERT INTO #__ev_secuwatch_requests 
					(is_admin, date_time, ip, request_url, more_details, token, recon_status
						,applied_rule_id, is_blocked, is_js, req_reason, bot_id, bot_spoofing	
						) 
					VALUES ( '".$this->_cm_isAdmin."','$d', '$ip', '$reqUrl', '$md', '$token', '$recon_status'
							, '$applied_rule_id', '$is_blocked', '$is_js','$req_reason', '$bot_id'
							, '$bot_spoofing'
							) ";
			$this->doQuery($q);
			
		}else{
			//x $idr = EvGeneCompoHelperSW::lastInsertedId();
			//x $this->_objProH->blockRequest($idr, $arrStatus[0], 0, true);
			$this->_objProH->blockRequest(0, $arrStatus[0], 0, true);
		}
		
		$res = EvGeneCompoHelperSW::sendRequestToCheckThisRequest( $token );
	}
	
	private function loadComponent(){
		try{
			if (!class_exists('EvGeneCompoHelperSW')) {
				require_once (JPATH_ADMINISTRATOR .'/components/com_ev_secuwatch/helper.php');
			}

		}catch(Exception $e){ return; }
		
		$this->_installed=true;
	}

	//db funcs
	function lastInsertedId(){
		$db	= JFactory::getDBO();
		return $db->insertid();
	}

	function recsAffected(){
		$db	= JFactory::getDBO();
		return $db->getAffectedRows();
	}

	function getResult( $query ){
		$db	= JFactory::getDBO();

		$db->setQuery( $query );
		return $db->loadResult();
	}

	function doQuery( $query ){
		$db	= JFactory::getDBO();
		$db->setQuery( $query );

	    return $db->query();
	}

	function getRows( $query, $limitStart=0, $recs=0 ){
		$db	= JFactory::getDBO();

		if ( $recs > 0 ) {
			$db->setQuery( $query, $limitStart, $recs );
		}else{
			$db->setQuery( $query );
		}

		$rows = $db->loadObjectList();
		return $rows;
	}

	function getRow( $query ){
	    $rows = $this->getRows( $query );
		$row  = '';
		if ( count( $rows ) > 0 ) $row  = $rows[0];
		return $row;
	}
	
}